/*
	ZLG7290.c
	ʾ̹оƬZLG7290ı׼80C51Cļ
	Copyright (c) 2005Ƭչ޹˾
	All rights reserved.
	ѧϰοṩκοɿԷĵҵĿ
*/

#include "I2C.h"
#include "ZLG7290.h"

/*
ZLG7290_WriteReg()
ܣZLG7290ĳڲĴд

	RegAddrZLG7290ڲĴַ
	datҪд
أ
	0
	1ZLG7290ʱ쳣
*/
bit ZLG7290_WriteReg(unsigned char RegAddr, char dat)
{
	bit b;
	b = I2C_Puts(ZLG7290_I2C_ADDR,RegAddr,1,&dat,1);
	return b;
}

/*
ZLG7290_ReadReg()
ܣZLG7290ĳڲĴ

	RegAddrZLG7290ڲĴַ
	*dat
أ
	0
	1ZLG7290ʱ쳣
*/
bit ZLG7290_ReadReg(unsigned char RegAddr, char *dat)
{
	bit b;
	b = I2C_Gets(ZLG7290_I2C_ADDR,RegAddr,1,dat,1);
	return b;
}

/*
ZLG7290_cmd()
ܣZLG7290Ϳ

	cmd0дCmdBuf0Ĵ֣1ֽڣ
	cmd1дCmdBuf1Ĵ֣2ֽڣ
أ
	0
	1ZLG7290ʱ쳣
*/
bit ZLG7290_cmd(char cmd0, char cmd1)
{
	bit b;
	char buf[2];
	buf[0] = cmd0;
	buf[1] = cmd1;
	b = I2C_Puts(ZLG7290_I2C_ADDR,ZLG7290_CmdBuf,1,buf,2);
	return b;
}

/*
ZLG7290_SegOnOff()
ܣѰַϨܣLEDеĳһ

	segȡֵ063ʾܣLEDĶκ
	b0ʾϨ1ʾ
أ
	0
	1ZLG7290ʱ쳣
˵
	ÿһλУκ˳աa,b,c,d,e,f,g,dp
*/
bit ZLG7290_SegOnOff(char seg, bit b)
{
	char cmd;
	cmd = seg & 0x3F;
	if ( b ) cmd |= 0x80;
	return ZLG7290_cmd(0x01,cmd);
}

/*
ZLG7290_Download()
ܣݲ

	addrȡֵ07ʾDpRam0DpRam7ı
	dpǷλС㣬0Ϩ1
	flashƸλǷ˸0˸1˸
	datȡֵ031ʾҪʾ
أ
	0
	1ZLG7290ʱ쳣
˵
	ʾݾ뷽ʽμZLG7290ֲ
*/
bit ZLG7290_Download(char addr, bit dp, bit flash, char dat)
{
	char cmd0;
	char cmd1;
	cmd0 = addr & 0x0F;
	cmd0 |= 0x60;
	cmd1 = dat & 0x1F;
	if ( dp ) cmd1 |= 0x80;
	if ( flash ) cmd1 |= 0x40;
	return ZLG7290_cmd(cmd0,cmd1);
}
